<template lang="pug">
  .action-content
    search(
      @suggest-start="searchSuggesting = true"
      @suggest-stop="searchSuggesting = false"
      @start="startSearch()"
      @stop="stopSearch()"
      @clear="clearSearch()"
      @close="$emit('close')"
    )
    .list-shadow(v-if="searchSuggesting")
    header(
      v-if="currentAction === entity"
      v-for="entity in [ACTION_OBJECTS, ACTION_MODELS, ACTION_BACKGROUNDS]"
      :key="`${entity}Header`"
    )
      .title
        div {{ currentAction }}
        .loading(v-if="searching")
        .badge.red(v-if="!searching && getSearchItemsLength(currentAction)") {{ getSearchTotal(currentAction) }}
        .spacer(v-show="currentAction !== ACTION_BACKGROUNDS")
        .picker.button.icon(
          v-show="currentAction === ACTION_BACKGROUNDS"
          v-tooltip:right="'Set background color'"
          @click="$emit('toggle-background-color-picker')"
          ref="backgroundColorPickerButton"
        )
          .icon
            img(src='~static/vue-static/swatch.png')
        .spacer
        select-menu(
          v-if="[ACTION_OBJECTS, ACTION_MODELS, ACTION_BACKGROUNDS].includes(currentAction)"
          :currentItemId="currentEntity.sorting"
          :items="sortItems"
          @select="sort"
        )
    user-upload(v-if="currentAction === ACTION_UPLOADS" ref="userUpload")
    text-properties(
      v-if="currentAction === ACTION_TEXT"
      @selected="$emit('selected', ACTION_TEXT)"
      ref="textProperties"
    )
    .list-container(
      v-if="currentAction === entity"
      v-for="entity in [ACTION_OBJECTS, ACTION_MODELS, ACTION_BACKGROUNDS, ACTION_UPLOADS]"
      :key="entity"
    )
      list(
        v-if="isSearch && [ACTION_OBJECTS, ACTION_MODELS, ACTION_BACKGROUNDS].includes(currentAction)"
        @selected="$emit('selected', entity)"
        :entity="`search${entity.charAt(0).toUpperCase() + entity.slice(1)}`"
        :isSearching="searching"
        :isSorting="sorting"
        ref="list"
      )
      list(
        v-else
        @selected="$emit('selected', entity)"
        :entity="entity"
        :isSorting="sorting"
        ref="list"
      )
</template>

<script>
import { mapState } from 'vuex'
import itemsService from '../services/items/common'
import modelService from '../services/items/model'
import objectService from '../services/items/object'
import backgroundService from '../services/items/background'

export default {
  name: 'ActionContent',
  data () {
    return {
      ACTION_OBJECTS: itemsService.ACTION_OBJECTS,
      ACTION_MODELS: itemsService.ACTION_MODELS,
      ACTION_BACKGROUNDS: itemsService.ACTION_BACKGROUNDS,
      ACTION_TEXT: itemsService.ACTION_TEXT,
      ACTION_UPLOADS: itemsService.ACTION_UPLOADS,
      SORT_RISING: modelService.SORT_RISING,
      showSortingMenu: false,
      searching: false,
      sorting: false,
      isSearch: false,
      searchSuggesting: false,
      sortItems: []
    }
  },
  computed: {
    ...mapState({
      searchQuery: state => state.editor.searchQuery,
      searchModels: state => state.editor.searchModels,
      searchObjects: state => state.editor.searchObjects,
      searchBackgrounds: state => state.editor.searchBackgrounds,
      currentAction: state => state.editor.currentAction,
      currentActionSorting: state => {
        let sorting
        switch (state.editor.currentAction) {
          case 'backgrounds':
            sorting = state.editor.backgrounds.sorting
            break
          case 'models':
            sorting = state.editor.models.sorting
            break
          case 'objects':
            sorting = state.editor.objects.sorting
            break
        }
        return sorting
      }
    }),
    currentEntity () {
      let entity

      switch (this.currentAction) {
        case 'backgrounds':
          entity = this.searchQuery ? 'searchBackgrounds' : 'backgrounds'
          break
        case 'models':
          entity = this.searchQuery ? 'searchModels' : 'models'
          break
        case 'objects':
          entity = this.searchQuery ? 'searchObjects' : 'objects'
          break
      }

      return this.$store.state.editor[entity]
    }
  },
  created () {
    switch (this.currentAction) {
      case 'backgrounds':
        this.sortItems = backgroundService.SORTINGS
        break
      case 'models':
        this.sortItems = modelService.SORTINGS
        break
      case 'objects':
        this.sortItems = objectService.SORTINGS
        break
    }
  },
  methods: {
    sort (sortItem) {
      this.sorting = true
      let promise = Promise.resolve()

      switch (this.currentAction) {
        case 'backgrounds':
          promise = backgroundService.sort(sortItem.id)
          break
        case 'models':
          promise = modelService.sort(sortItem.id)
          break
        case 'objects':
          promise = objectService.sort(sortItem.id)
          break
      }

      promise
        .then(() => {
          this.sorting = false
        })
    },
    getSearchTotal (tabName) {
      const fieldName = `search${tabName.charAt(0).toUpperCase() + tabName.slice(1)}`
      if (this[fieldName]) {
        return this[`search${tabName.charAt(0).toUpperCase() + tabName.slice(1)}`].total
      }
      return 0
    },
    getSearchItemsLength (tabName) {
      const fieldName = `search${tabName.charAt(0).toUpperCase() + tabName.slice(1)}`
      if (this[fieldName]) {
        return this[fieldName].items.length
      }
      return 0
    },
    startSearch () {
      this.searching = true
      this.isSearch = true
    },
    stopSearch () {
      this.searching = false

      // Set first tab with results if there is no one in current or there is no one result in all tabs
      const isSomeResults = !!(this.searchModels.items.length || this.searchObjects.items.length || this.searchBackgrounds.items.length)
      const searchField = `search${this.currentAction.charAt(0).toUpperCase() + this.currentAction.slice(1)}`
      if (isSomeResults && (!this[searchField] || !this[searchField].items.length)) {
        let somethingFoundTab = this.ACTION_MODELS

        if (this.searchModels.items.length) {
        } else if (this.searchObjects.items.length) {
          somethingFoundTab = this.ACTION_OBJECTS
        } else if (this.searchBackgrounds.items.length) {
          somethingFoundTab = this.ACTION_BACKGROUNDS
        }

        this.$store.dispatch('setCurrentAction', somethingFoundTab)
      }
    },
    clearSearch () {
      this.searching = false
      this.isSearch = false
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../assets/css/mixins';
@import '../assets/css/variables';

.action-content {
  width: 100%;
  height: 100%;
  height: calc(var(--vh, 1vh) * 100);
  transition: 0.5s;
  background-color: $sidebar-background-color;

  .search {
    z-index: 20;
  }

  .list-shadow {
    width: calc(100% - 8px);
    height: 100%;
    position: absolute;
    z-index: 10;
    background-color: rgba(33, 33, 33, 0.9);
  }

  header {
    .title {
      padding: 0 10px 0 4px;
      margin-bottom: 40px;
      align-items: center;
      display: flex;
      color: #fff;
      text-transform: uppercase;
      height: 56px;
      font-size: 24px;
      font-weight: bold;

      .picker {
        margin-left: 16px;
      }

      .button {
        width: 24px;
      }

      .badge {
        margin-left: 8px;
        padding: 0 5px;
      }

      .loading {
        width: 22px;
        height: 22px;
        margin-left: 12px;
        position: relative;
        @include loading(#fff, 3px, 22px);
      }
    }
  }

  .title {
    img {
      width: 24px;
    }
  }

  .list-container {
    height: calc(100% - 112px);
    z-index: 10;
  }
}
</style>
